
module Make

# 4 "parser.mly"
          (Semantics : sig
  type number
  val inject: int -> number
  val ( + ): number -> number -> number
  val ( - ): number -> number -> number
  val ( * ): number -> number -> number
  val ( / ): number -> number -> number
  val ( ~-): number -> number
end)
# 15 "parser.ml"

= struct
  
  module MenhirBasics = struct
    
    exception Error
    
    type token = Tokens.token
    
  end
  
  include MenhirBasics
  
  let _eRR =
    MenhirBasics.Error
  
  type _menhir_env = {
    _menhir_lexer: Lexing.lexbuf -> token;
    _menhir_lexbuf: Lexing.lexbuf;
    _menhir_token: token;
    mutable _menhir_error: bool
  }
  
  and _menhir_state = 
    | MenhirState12
    | MenhirState10
    | MenhirState8
    | MenhirState5
    | MenhirState2
    | MenhirState1
    | MenhirState0
  
# 22 "parser.mly"
  

  open Semantics


# 54 "parser.ml"
  
  let rec _menhir_run5 : _menhir_env -> 'ttv_tail * _menhir_state * (Semantics.number) -> 'ttv_return =
    fun _menhir_env _menhir_stack ->
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState5 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState5
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState5
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState5
  
  and _menhir_run8 : _menhir_env -> 'ttv_tail * _menhir_state * (Semantics.number) -> 'ttv_return =
    fun _menhir_env _menhir_stack ->
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState8 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState8
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState8
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState8
  
  and _menhir_run12 : _menhir_env -> 'ttv_tail * _menhir_state * (Semantics.number) -> 'ttv_return =
    fun _menhir_env _menhir_stack ->
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState12 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState12
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState12
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState12
  
  and _menhir_run10 : _menhir_env -> 'ttv_tail * _menhir_state * (Semantics.number) -> 'ttv_return =
    fun _menhir_env _menhir_stack ->
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState10 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState10
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState10
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState10
  
  and _menhir_goto_expr : _menhir_env -> 'ttv_tail -> _menhir_state -> (Semantics.number) -> 'ttv_return =
    fun _menhir_env _menhir_stack _menhir_s _v ->
      let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
      match _menhir_s with
      | MenhirState2 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          assert (not _menhir_env._menhir_error);
          let _tok = _menhir_env._menhir_token in
          (match _tok with
          | Tokens.DIV ->
              _menhir_run10 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.MINUS ->
              _menhir_run12 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.PLUS ->
              _menhir_run8 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.RPAREN ->
              let _menhir_stack = Obj.magic _menhir_stack in
              let _menhir_env = _menhir_discard _menhir_env in
              let _menhir_stack = Obj.magic _menhir_stack in
              let ((_menhir_stack, _menhir_s), _, (e : (Semantics.number))) = _menhir_stack in
              let _3 = () in
              let _1 = () in
              let _v : (Semantics.number) = 
# 38 "parser.mly"
    ( e )
# 145 "parser.ml"
               in
              _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
          | Tokens.TIMES ->
              _menhir_run5 _menhir_env (Obj.magic _menhir_stack)
          | _ ->
              assert (not _menhir_env._menhir_error);
              _menhir_env._menhir_error <- true;
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_menhir_stack, _menhir_s, _) = _menhir_stack in
              _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s)
      | MenhirState5 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let _menhir_stack = Obj.magic _menhir_stack in
          let ((_menhir_stack, _menhir_s, (e1 : (Semantics.number))), _, (e2 : (Semantics.number))) = _menhir_stack in
          let _2 = () in
          let _v : (Semantics.number) = 
# 44 "parser.mly"
    ( e1 * e2 )
# 164 "parser.ml"
           in
          _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
      | MenhirState8 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          assert (not _menhir_env._menhir_error);
          let _tok = _menhir_env._menhir_token in
          (match _tok with
          | Tokens.DIV ->
              _menhir_run10 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.TIMES ->
              _menhir_run5 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.EOL | Tokens.MINUS | Tokens.PLUS | Tokens.RPAREN ->
              let _menhir_stack = Obj.magic _menhir_stack in
              let ((_menhir_stack, _menhir_s, (e1 : (Semantics.number))), _, (e2 : (Semantics.number))) = _menhir_stack in
              let _2 = () in
              let _v : (Semantics.number) = 
# 40 "parser.mly"
    ( e1 + e2 )
# 183 "parser.ml"
               in
              _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
          | _ ->
              assert (not _menhir_env._menhir_error);
              _menhir_env._menhir_error <- true;
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_menhir_stack, _menhir_s, _) = _menhir_stack in
              _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s)
      | MenhirState10 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let _menhir_stack = Obj.magic _menhir_stack in
          let ((_menhir_stack, _menhir_s, (e1 : (Semantics.number))), _, (e2 : (Semantics.number))) = _menhir_stack in
          let _2 = () in
          let _v : (Semantics.number) = 
# 46 "parser.mly"
    ( e1 / e2 )
# 200 "parser.ml"
           in
          _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
      | MenhirState12 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          assert (not _menhir_env._menhir_error);
          let _tok = _menhir_env._menhir_token in
          (match _tok with
          | Tokens.DIV ->
              _menhir_run10 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.TIMES ->
              _menhir_run5 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.EOL | Tokens.MINUS | Tokens.PLUS | Tokens.RPAREN ->
              let _menhir_stack = Obj.magic _menhir_stack in
              let ((_menhir_stack, _menhir_s, (e1 : (Semantics.number))), _, (e2 : (Semantics.number))) = _menhir_stack in
              let _2 = () in
              let _v : (Semantics.number) = 
# 42 "parser.mly"
    ( e1 - e2 )
# 219 "parser.ml"
               in
              _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
          | _ ->
              assert (not _menhir_env._menhir_error);
              _menhir_env._menhir_error <- true;
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_menhir_stack, _menhir_s, _) = _menhir_stack in
              _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s)
      | MenhirState1 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let _menhir_stack = Obj.magic _menhir_stack in
          let ((_menhir_stack, _menhir_s), _, (e : (Semantics.number))) = _menhir_stack in
          let _1 = () in
          let _v : (Semantics.number) = 
# 48 "parser.mly"
    ( - e )
# 236 "parser.ml"
           in
          _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
      | MenhirState0 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          assert (not _menhir_env._menhir_error);
          let _tok = _menhir_env._menhir_token in
          match _tok with
          | Tokens.DIV ->
              _menhir_run10 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.EOL ->
              let _menhir_stack = Obj.magic _menhir_stack in
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_menhir_stack, _menhir_s, (e : (Semantics.number))) = _menhir_stack in
              let _2 = () in
              let _v : (
# 17 "parser.mly"
       (Semantics.number)
# 254 "parser.ml"
              ) = 
# 32 "parser.mly"
    ( e )
# 258 "parser.ml"
               in
              let _menhir_stack = Obj.magic _menhir_stack in
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_1 : (
# 17 "parser.mly"
       (Semantics.number)
# 265 "parser.ml"
              )) = _v in
              Obj.magic _1
          | Tokens.MINUS ->
              _menhir_run12 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.PLUS ->
              _menhir_run8 _menhir_env (Obj.magic _menhir_stack)
          | Tokens.TIMES ->
              _menhir_run5 _menhir_env (Obj.magic _menhir_stack)
          | _ ->
              assert (not _menhir_env._menhir_error);
              _menhir_env._menhir_error <- true;
              let _menhir_stack = Obj.magic _menhir_stack in
              let (_menhir_stack, _menhir_s, _) = _menhir_stack in
              _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
  
  and _menhir_errorcase : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
    fun _menhir_env _menhir_stack _menhir_s ->
      match _menhir_s with
      | MenhirState12 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s, _) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState10 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s, _) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState8 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s, _) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState5 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s, _) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState2 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState1 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          let (_menhir_stack, _menhir_s) = _menhir_stack in
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s
      | MenhirState0 ->
          let _menhir_stack = Obj.magic _menhir_stack in
          raise _eRR
  
  and _menhir_run1 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
    fun _menhir_env _menhir_stack _menhir_s ->
      let _menhir_stack = (_menhir_stack, _menhir_s) in
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState1 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState1
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState1
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState1
  
  and _menhir_run2 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
    fun _menhir_env _menhir_stack _menhir_s ->
      let _menhir_stack = (_menhir_stack, _menhir_s) in
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState2 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState2
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState2
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState2
  
  and _menhir_run3 : _menhir_env -> 'ttv_tail -> _menhir_state -> (
# 5 "tokens.mly"
       (int)
# 349 "parser.ml"
  ) -> 'ttv_return =
    fun _menhir_env _menhir_stack _menhir_s _v ->
      let _menhir_env = _menhir_discard _menhir_env in
      let _menhir_stack = Obj.magic _menhir_stack in
      let (i : (
# 5 "tokens.mly"
       (int)
# 357 "parser.ml"
      )) = _v in
      let _v : (Semantics.number) = 
# 36 "parser.mly"
    ( inject i )
# 362 "parser.ml"
       in
      _menhir_goto_expr _menhir_env _menhir_stack _menhir_s _v
  
  and _menhir_discard : _menhir_env -> _menhir_env =
    fun _menhir_env ->
      let lexer = _menhir_env._menhir_lexer in
      let lexbuf = _menhir_env._menhir_lexbuf in
      let _tok = lexer lexbuf in
      {
        _menhir_lexer = lexer;
        _menhir_lexbuf = lexbuf;
        _menhir_token = _tok;
        _menhir_error = false;
      }
  
  and main : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (
# 17 "parser.mly"
       (Semantics.number)
# 381 "parser.ml"
  ) =
    fun lexer lexbuf ->
      let _menhir_env = let _tok = Obj.magic () in
      {
        _menhir_lexer = lexer;
        _menhir_lexbuf = lexbuf;
        _menhir_token = _tok;
        _menhir_error = false;
      } in
      Obj.magic (let _menhir_stack = ((), _menhir_env._menhir_lexbuf.Lexing.lex_curr_p) in
      let _menhir_env = _menhir_discard _menhir_env in
      let _tok = _menhir_env._menhir_token in
      match _tok with
      | Tokens.INT _v ->
          _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState0 _v
      | Tokens.LPAREN ->
          _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState0
      | Tokens.MINUS ->
          _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState0
      | _ ->
          assert (not _menhir_env._menhir_error);
          _menhir_env._menhir_error <- true;
          _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState0)
  
# 219 "/Users/fpottier/dev/menhir/src//standard.mly"
  


# 410 "parser.ml"
  
end
